#!/bin/bash

# 该操作较危险，故将其放在脚本中而不是使用C++编写

function main() {
    if ! apt update; then
        echo "Failed to update package list. Exiting."
        exit 1
    fi

    if [ -d "/var/lib/dpkg/info_old" ]; then
        # 将/var/lib/dpkg/info_old下的所有文件拷贝到到/var/lib/dpkg/info，如果已经存在则跳过
        for file in /var/lib/dpkg/info_old/*; do
            local filename
            filename=$(basename "$file")
            if [ ! -e "/var/lib/dpkg/info/$filename" ]; then
                cp "$file" "/var/lib/dpkg/info/"
            fi
        done

        rm -rf /var/lib/dpkg/info_old
    fi

    mv /var/lib/dpkg/info /var/lib/dpkg/info_old
    mkdir -p /var/lib/dpkg/info

    if ! apt install -fy; then
        rm -rf /var/lib/dpkg/info
        mv /var/lib/dpkg/info_old /var/lib/dpkg/info
        exit 0
    fi

    local num
    num=$(ls /var/lib/dpkg/info | wc -l)
    if [ "$num" -eq 0 ]; then
        rm -rf /var/lib/dpkg/info
        mv /var/lib/dpkg/info_old /var/lib/dpkg/info
        exit 0
    fi

    mv /var/lib/dpkg/info/* /var/lib/dpkg/info_old
    rm -rf /var/lib/dpkg/info
    mv /var/lib/dpkg/info_old /var/lib/dpkg/info
    exit 0
}

main
